clear all
close all
clc

%Sampling Frequency
D=2;
conf_lev = 0.05;
load(['../../data/CAViaR_bond_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'.mat']);
load(['../../data/CAViaR_equity_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'.mat']);

Ne = 33; % number of equities
Nb = 36; % number of bonds

% Width of the rolling window
DT = 100;
% Distance between two rolling windows
BW = 5;

kernel_type = 'DAN'; %kernel for the hong test
date_start = datenum('01-Jan-2001');
date_end = datenum('14-Feb-2014');

y_l=1;
T0=length(date_grid);
N_period = floor((T0-DT-1)/BW)+1;

my_M = 5;%,50,250];

number_of_link95 = zeros(N_period,length(my_M));
number_of_link99 = zeros(N_period,length(my_M));

number_of_link95_up = zeros(N_period,length(my_M));
number_of_link99_up = zeros(N_period,length(my_M));

number_of_link95_up_dw = zeros(N_period,length(my_M));
number_of_link99_up_dw = zeros(N_period,length(my_M));

number_of_link95_dw_up = zeros(N_period,length(my_M));
number_of_link99_dw_up = zeros(N_period,length(my_M));


number_of_pairs= zeros(N_period,1);
n_coppie_esluse=zeros(N_period,1);
average_corr_bond =zeros(N_period,1);
average_length =zeros(N_period,1); std_length =zeros(N_period,1);
number_of_bonds_used_for_correlation= zeros(N_period,1);
Vol_bond_1D_forward = zeros(N_period,36);
tempo = zeros(N_period,1);
wb = waitbar(0,'Please Wait');
time=1;
sample_bond=1:36;
%sample_bond=[sample_bond,26:36];

for period=1:N_period
    y_r = y_l + DT;
    tempo(period) = date_grid(y_r);
    
    for m=1:36
        tau=min(find(date_finale_bond{m}>=tempo(period)));
        fine_bond =length(bond_rates{m});
        if((~isempty(tau)) && (tau+1<=fine_bond))
            if(bond_rates{m}(tau+1)*bond_rates{m}(tau)~=0)
                Vol_bond_1D_forward(period,m) =  abs(log(bond_rates{m}(tau+1)/bond_rates{m}(tau)));
            else
                Vol_bond_1D_forward(period,m) = NaN;
            end
        else
            Vol_bond_1D_forward(period,m) = NaN;
        end
    end
    count=1;
    sub_count=1;
    for g=1:length(my_M)
        rej95(g)=0; rej99(g) = 0;
        rej95_up(g)=0; rej99_up(g) = 0;
        rej95_up_dw(g)=0; rej99_up_dw(g) = 0;
        rej95_dw_up(g)=0; rej99_dw_up(g) = 0;
    end
    rej_ftest_95 = 0;
    rej_ftest_99 = 0;
    average_corr_bond(period)=0;
    c_corr=0;
    clear tmp_std
    for m=1:36
        A = rb_subsampled_D{m}(y_l:y_r);
        for n=m+1:36
            B = rb_subsampled_D{n}(y_l:y_r);
            overlap=find( (isfinite(A)==1) & (isfinite(B)==1) );
            if(length(overlap)>20)
                A_ok = A(overlap); B_ok = B(overlap);
                c_corr=c_corr+1;
                average_length(period) = average_length(period)+length(overlap);
                tmp_std(c_corr) = length(overlap);
                tmp = corrcoef(A_ok,B_ok);
                tmp = tmp(1,2);
                average_corr_bond(period)=average_corr_bond(period)+tmp;
            end
        end
    end
    number_of_bonds_used_for_correlation(period)=c_corr;
    average_corr_bond(period)=average_corr_bond(period)/c_corr;
    average_length(period)=average_length(period)/c_corr;
    std_length(period) = std(tmp_std);
    for m=sample_bond
        z_bond = Hit_bond{m}(y_l:y_r);
        z_bond_up = Hit_bond_up{m}(y_l:y_r);
        Rating = bond_rating_subsampled_D{m}(y_l:y_r);
        return_bond = return_bond_GARCH{m}(y_l:y_r);
        tmp = rb_subsampled_D{m}(y_l:y_r);
        I = isfinite(tmp);
        vol_bond{m}(period) = sum(tmp(I).^2);
        I=find(isfinite(Rating)==1);
        if(length(I)>0)
            rating{period,m} = Rating(I(end));
        end
        for n=1:N_files_eq
            z_equity = Hit_equity{n}(y_l:y_r);
            z_equity_up = Hit_equity_up{n}(y_l:y_r);
            return_equity = return_equity_GARCH{n}(y_l:y_r);
            overlap=find((isfinite(z_equity)==1) & (isfinite(z_bond)==1) );
            T_eff = length(overlap);
            if(T_eff<50)
                n_coppie_esluse(period)=n_coppie_esluse(period)+1;
                Coppie_escluce{period,n_coppie_esluse(period)} = [m,n];
                g=1;
                for M=my_M
                    Q{period,count,g} =NaN;
                    g=g+1;
                end
                p_value{period,count} = NaN;
            else
                bond_presenti_bdeq{period}(sub_count) = m;
                equity_presenti_bdeq{period}(sub_count) = n;
                
                z_bond_ok = z_bond(overlap);
                z_equity_ok = z_equity(overlap);
                
                z_bond_up_ok = z_bond_up(overlap);
                z_equity_up_ok = z_equity_up(overlap);
                
                return_bond_ok = return_bond(overlap);
                return_equity_ok = return_equity(overlap);
                rho = rho_sample(z_bond_ok,z_equity_ok);
                rho = rho(end-(T_eff-2):end);
                if(size(rho,2)>1)
                    rho=rho';
                end
                rho_up = rho_sample(z_bond_up_ok,z_equity_up_ok);
                rho_up = rho_up(end-(T_eff-2):end);
                if(size(rho_up,2)>1)
                    rho_up=rho_up';
                end
                rho_up_dw = rho_sample(z_bond_up_ok,z_equity_ok);
                rho_up_dw = rho_up_dw(end-(T_eff-2):end);
                if(size(rho_up_dw,2)>1)
                    rho_up_dw=rho_up_dw';
                end
                rho_dw_up = rho_sample(z_bond_ok,z_equity_up_ok);
                rho_dw_up = rho_dw_up(end-(T_eff-2):end);
                if(size(rho_dw_up,2)>1)
                    rho_dw_up=rho_dw_up';
                end
                g=1;
                for M=my_M
                    Q{period,count,g} = hong_etal_test(rho,M,kernel_type);
                    Q_up{period,count,g} = hong_etal_test(rho_up,M,kernel_type);
                    Q_up_dw{period,count,g} = hong_etal_test(rho_up_dw,M,kernel_type);
                    Q_dw_up{period,count,g} = hong_etal_test(rho_dw_up,M,kernel_type);
                    % Negative ==> Negative
                    if(Q{period,count,g}>1.65)
                        Yongmiao_couples95{period,sub_count,g}=[m,n];
                        rej95(g)=rej95(g)+1;
                    else
                        Yongmiao_couples95{period,sub_count,g}=[NaN,NaN];
                    end
                    if(Q{period,count,g}>2.33)
                        Yongmiao_couples99{period,sub_count,g}=[m,n];
                        rej99(g)=rej99(g)+1;
                    else
                        Yongmiao_couples99{period,sub_count,g}=[NaN,NaN];
                    end
                    % Positive ==> Positive
                    if(Q_up{period,count,g}>1.65)
                        Yongmiao_couples95_up{period,sub_count,g}=[m,n];
                        rej95_up(g)=rej95_up(g)+1;
                    else
                        Yongmiao_couples95_up{period,sub_count,g}=[NaN,NaN];
                    end
                    if(Q_up{period,count,g}>2.33)
                        Yongmiao_couples99_up{period,sub_count,g}=[m,n];
                        rej99_up(g)=rej99_up(g)+1;
                    else
                        Yongmiao_couples99_up{period,sub_count,g}=[NaN,NaN];
                    end
                    % Negative ==> Positive
                    if(Q_up_dw{period,count,g}>1.65)
                        Yongmiao_couples95_up_dw{period,sub_count,g}=[m,n];
                        rej95_up_dw(g)=rej95_up_dw(g)+1;
                    else
                        Yongmiao_couples95_up_dw{period,sub_count,g}=[NaN,NaN];
                    end
                    if(Q_up_dw{period,count,g}>2.33)
                        Yongmiao_couples99_up_dw{period,sub_count,g}=[m,n];
                        rej99_up_dw(g)=rej99_up_dw(g)+1;
                    else
                        Yongmiao_couples99_up_dw{period,sub_count,g}=[NaN,NaN];
                    end
                    % Positive ==> Negative
                    if(Q_dw_up{period,count,g}>1.65)
                        Yongmiao_couples95_dw_up{period,sub_count,g}=[m,n];
                        rej95_dw_up(g)=rej95_dw_up(g)+1;
                    else
                        Yongmiao_couples95_dw_up{period,sub_count,g}=[NaN,NaN];
                    end
                    if(Q_dw_up{period,count,g}>2.33)
                        Yongmiao_couples99_dw_up{period,sub_count,g}=[m,n];
                        rej99_dw_up(g)=rej99_dw_up(g)+1;
                    else
                        Yongmiao_couples99_dw_up{period,sub_count,g}=[NaN,NaN];
                    end
                    g=g+1;
                end
                Y = return_bond_ok(2:end); T_regress = length(Y);
                Y = Y';
                X  = zeros(T_eff-1,2);
                X(:,1) = return_equity_ok(1:end-1);
                % Instantaneous causality.
                %X(:,2) = return_equity_ok(2:end);
                X(:,2) = return_bond_ok(1:end-1);
                result = ols(Y,[ones(size(Y)),X]);
                save_beta = result.beta(2);
                e2 = result.resid;
                X = X(:,2);
                result = ols(Y,[ones(size(Y)),X]);
                e1 = result.resid;
                p_value{period,count} = ftest(2,4,T_regress,e1,e2);
                if(p_value{period,count}<0.05)
                    Billio_couples95{period,sub_count}=[m,n];
                    beta_granger_bdeq{period,sub_count} = save_beta;
                    rej_ftest_95=rej_ftest_95+1;
                else
                    beta_granger_bdeq{period,sub_count} = NaN;
                    Billio_couples95{period,sub_count}=[NaN,NaN];
                end
                if(p_value{period,count}<0.01)
                    Billio_couples99{period,sub_count}=[m,n];
                    rej_ftest_99=rej_ftest_99+1;
                else
                    Billio_couples99{period,sub_count}=[NaN,NaN];
                end
                sub_count=sub_count+1;
            end
            length_overlap{period,count} = length(overlap);
            count=count+1;
        end
    end
    number_of_pairs(period) = sub_count;
    for g=1:length(my_M)
        number_of_link95(period,g) = 100*rej95(g)/(sub_count);
        number_of_link99(period,g) = 100*rej99(g)/(sub_count);
        number_of_link95_up(period,g) = 100*rej95_up(g)/(sub_count-1);
        number_of_link99_up(period,g) = 100*rej99_up(g)/(sub_count-1);
        number_of_link95_up_dw(period,g) = 100*rej95_up_dw(g)/(sub_count-1);
        number_of_link99_up_dw(period,g) = 100*rej99_up_dw(g)/(sub_count-1);
        number_of_link95_dw_up(period,g) = 100*rej95_dw_up(g)/(sub_count-1);
        number_of_link99_dw_up(period,g) = 100*rej99_dw_up(g)/(sub_count-1);
    end
    number_of_link_ftest95(period) = 100*rej_ftest_95/(sub_count);
    number_of_link_ftest99(period) = 100*rej_ftest_99/(sub_count);
    y_l = y_l+BW;
    waitbar(period/N_period,wb);
end
%
tosave = ['../../data/CAViaR_rolling_granger_sample_variabile_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'.mat'];
save(tosave)


close all

figure(1),
plot(tempo,number_of_link95(:,1),'-k','LineWidth',2),datetick('x','yyyy','keeplimits'),xlim([tempo(1) tempo(end)]),ylim([0 35])
xlabel('Date','Interpreter','LaTex'), ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex'), grid on
title('$\textrm{Equity}^{(-)}\Longrightarrow \textrm{Bond}^{(-)}$','Interpreter','LaTex')
hline(5,'--k')
exportfig(1,['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_nn.eps'],...
     'width',15,'height',10,'color','rgb','fontsize',2.2);
source= ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_nn.eps'];
dest  = ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_nn.pdf'];
eps2pdf(source,dest,1)
delete(source)

figure(2),
plot(tempo,number_of_link95_up(:,1),'-k','LineWidth',2),datetick('x','yyyy','keeplimits'),xlim([tempo(1) tempo(end)]),ylim([0 35])
xlabel('Date','Interpreter','LaTex'),ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex'), grid on
title('$\textrm{Equity}^{(+)}\Longrightarrow \textrm{Bond}^{(+)}$','Interpreter','LaTex')
hline(5,'--k')
exportfig(2,['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pp.eps'],...
     'width',15,'height',10,'color','rgb','fontsize',2.2);
source= ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pp.eps'];
dest  = ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pp.pdf'];
eps2pdf(source,dest,1)
delete(source)

figure(3),
plot(tempo,number_of_link95_up_dw(:,1),'-k','LineWidth',2),datetick('x','yyyy','keeplimits'),xlim([tempo(1) tempo(end)]),ylim([0 35])
xlabel('Date','Interpreter','LaTex'),ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex'), grid on
title('$\textrm{Equity}^{(-)}\Longrightarrow \textrm{Bond}^{(+)}$','Interpreter','LaTex')
hline(5,'--k')
exportfig(3,['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pn.eps'],...
     'width',15,'height',10,'color','rgb','fontsize',2.2);
source= ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pn.eps'];
dest  = ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_pn.pdf'];
eps2pdf(source,dest,1)
delete(source)

figure(4),
plot(tempo,number_of_link95_dw_up(:,1),'-k','LineWidth',2),datetick('x','yyyy','keeplimits'),
xlim([tempo(1) tempo(end)]),ylim([0 35])
xlabel('Date','Interpreter','LaTex'),ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex'), grid on
title('$\textrm{Equity}^{(+)}\Longrightarrow \textrm{Bond}^{(-)}$','Interpreter','LaTex')
hline(5,'--k')
grid on
datetick('x','yyyy','keeplimits')
%legend(['M=',num2str(my_M(1))],['M=',num2str(my_M(2))],['M=',num2str(my_M(3))],0)
xlabel('Date','Interpreter','LaTex')
ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex')
exportfig(4,['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_np.eps'],...
     'width',15,'height',10,'color','rgb','fontsize',2.2);
source= ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_np.eps'];
dest  = ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_np.pdf'];
eps2pdf(source,dest,1)
delete(source)

figure(5)
plot(tempo,number_of_link_ftest95,'-k','LineWidth',2),datetick('x','yyyy','keeplimits'),
xlim([tempo(1) tempo(end)]),ylim([0 35])
xlabel('Date','Interpreter','LaTex'),ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex'), grid on
hline(5,'--k')
grid on
%legend(['M=',num2str(my_M(1))],['M=',num2str(my_M(2))],['M=',num2str(my_M(3))],0)
xlabel('Date','Interpreter','LaTex')
ylabel('Percentage of $95\%$-Significant Links ($\%$)','Interpreter','LaTex')
title('Equity$\stackrel{G}{\Longrightarrow}$Bond','Interpreter','LaTex')
exportfig(5,['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_G.eps'],...
     'width',15,'height',10,'color','rgb','fontsize',2.2);
source= ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_G.eps'];
dest  = ['../../figures/Granger/CAViaR_NofLinks_bd_eq_DT_',num2str(DT),'_BW_',num2str(BW),'_D',num2str(D),'_alpha',num2str(conf_lev*100),'_G.pdf'];
eps2pdf(source,dest,1)
delete(source)


% 
% Max_Lag=20; NWlag = floor(DT/2);
% Y = average_corr_bond;
% I = find(isfinite(Y)==1); Y = Y(I); dY=diff(Y); tempo_ora = tempo(I); tempo_ora = tempo_ora(2:end);
% n1 = number_of_link95(I,1); n2 = number_of_link_ftest95(I); n2 = n2';
% dn1 = diff(n1); dn2 = diff(n2);
% X=[ones(size(dY)),lag(dY),dn1,lag(dn1),dn2,lag(dn2)];
% clear result
% result{1}=nwest(dY(end-150:end),X(end-150:end,:),NWlag);
% Tstat{1} = result{1}.tstat;
% M = length(dY);
% BIC(1) = M*log(sum((result{1}.resid).^2)/M)+2*(6)*log(log(M));
% for l=2:Max_Lag
%     X=[X,lag(dY,l),lag(dn1,l),lag(dn2,l)];
%     result{l}=nwest(dY,X,NWlag);
%     Tstat{l} = result{l}.tstat;
%     [a npar]=size(X);
%     BIC(l) = M*log(sum((result{l}.resid).^2)/M)+2*npar*log(log(M));
%     rss(l) = sum((result{l}.resid).^2);
% end
% 
% figure(2)
% plot(tempo(I),Y,'-k','LineWidth',1),grid on
% xlim([tempo_ora(1) tempo_ora(end)])
% datetick('x','yyyy-mm','keeplimits')
% xlabel('Date')




