clear all
close all
clc

o_overlap=1; % If o_overlap = 0 then computes yearly non-overlapping estimates

load ../../data/bond_prices_and_dates.mat

%Sampling Frequency
D=2;
load ../../data/correspondence_countries-bonds.mat
load ../../data/ratings.mat

time_elapsed = 1;
wb = waitbar(0,'Please wait.');
date_start = datenum('01-Jan-2001');
if(o_overlap)
    date_end = datenum('01-Jan-2006');
else
    YEAR = 2002;
    date_end = datenum('31-Dec-2002');
end
final_date = datenum('14-Feb-2014');
DAYS = 30;
while date_end<=final_date

    every_1_day = date_start:1:date_end;
    every_1_day(find((weekday(every_1_day)==1) | (weekday(every_1_day)==7))) = [];
    date_grid = every_1_day(1:D:end);
    spec = garchset('Display','off','P',1,'Q',1);
    if( (~o_overlap) )
       tmp=datenum(['01-Jan-',num2str(YEAR)]);
       inizio_anno(time_elapsed) = min(find(date_grid>=tmp));
    end
    conf_lev = 0.10;
    bond_scartati = 0;
    for n=1:36
        if(time_elapsed==1)
            date_rating{country_corr(n)} = date_rating{country_corr(n)}';
        end
        %Year,Month,n
        i=1;
        for t=date_grid
            Q=find(date_finale_bond{n}<=t);
            if(isempty(Q))
                bond_rates_subsampled_D{n}(i) = NaN;
                
                bond_rating_subsampled_D{n}(i) = NaN;
                
            else
                tau=max(Q);
                bond_rates_subsampled_D{n}(i) = bond_rates{n}(tau);
                before = find((date_rating{country_corr(n)}>=date_finale_bond{n}(tau)) & (isfinite(rating{country_corr(n)})==1) );
                
                if(isempty(before))
                    after = find(date_rating{country_corr(n)}<=date_finale_bond{n}(tau) & (isfinite(rating{country_corr(n)})==1) );
                    bond_rating_subsampled_D{n}(i) = rating{country_corr(n)}(max(after));
                else
                    bond_rating_subsampled_D{n}(i) = rating{country_corr(n)}(min(before));
                end
                
            end
            i=i+1;
        end
        rb_subsampled_D{n}=diff((bond_rates_subsampled_D{n}));
        % Levo la prima obs in modo da essere compatibile con le diff di
        % bond rates :
        bond_rating_subsampled_D{n} = bond_rating_subsampled_D{n}(2:end);
        I = find(isnan(rb_subsampled_D{n})==1);
        presenti = length(rb_subsampled_D{n})-length(I);
        if(presenti<100)
            bond_scartati = bond_scartati+1;
            id_bond_scartati(bond_scartati) = n;
        else
            if(length(I)>0)
                min_nan(n) = max(I);
            else
                min_nan(n) = 0;
            end
            [Coeff,Errors,LLF,Innovations,Sigmas,Summary] = garchfit(spec,rb_subsampled_D{n});
            Sig = zeros(size(rb_subsampled_D{n}));
            Sig(1:min_nan(n))=NaN;
            Sig(min_nan(n)+1:end ) = Sigmas;
            return_bond_GARCH{n} = rb_subsampled_D{n}./Sig;
            
            %if(n~=25) % Hong-Kong absent!!
            Y=rb_subsampled_D{n}';
            Y = Y (min_nan(n)+1:end);
            
            LY = length(Y);
            yzeros= find(Y==0);
            non_zero = find(Y~=0);
            Ynnzero = Y(non_zero);
            
            [BetaHat_rb_prefilter{n}, output_rb_prefilter{n}, TABLE_rb_prefilter{n}] = Engle_Manganelli_CAViaROptimisation_DEBUGGED(2,conf_lev,Ynnzero,100,2);
            hit_tmp = zeros(LY,1);
            hit_tmp(non_zero) = output_rb_prefilter{n}.Hit+conf_lev;
            hit_tmp(yzeros) = zeros(size(yzeros));
            
            hit_up_tmp =  zeros(LY,1);
            hit_up_tmp(non_zero) = (Ynnzero>=output_rb_prefilter{n}.VaR);
            hit_up_tmp(yzeros) = zeros(size(yzeros));
            
            Hit_bond{n} = zeros(length(rb_subsampled_D{n}),1);
            Hit_bond{n}(1:min_nan(n))     = NaN*ones(min_nan(n),1);
            Hit_bond{n}(min_nan(n)+1:end) = hit_tmp;
            
            % Assume a symmetric (e.g. Gaussian) distribution....
            
            Hit_bond_up{n} =   zeros(length(rb_subsampled_D{n}),1);
            Hit_bond_up{n}(1:min_nan(n))     = NaN*ones(min_nan(n),1);
            Hit_bond_up{n}(min_nan(n)+1:end) = hit_up_tmp;
            
        end
        
    end
    %
    %         close all
    %         toplot=1;
    %         for n=1:6
    %             figure(n),
    %             for nplot=1:6
    %                 subplot(3,2,nplot),plot(date_grid(2:end),rb_subsampled_D{toplot}),grid on,title(nome_bond{toplot})
    %                 xlim([date_grid(1) date_grid(end)])
    %                 datetick('x','yyyy')
    %                 toplot=toplot+1;
    %             end
    %         end
    if(o_overlap)
        tosave=strcat('../../../../data_reservoir/caviar/bonds_fast_comp/',num2str(DAYS),'days/CAViaR_bond_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'_',num2str(time_elapsed),'.mat');%,date_end_str,'.mat');
    else
        tosave=strcat('../../../../data_reservoir/caviar/bonds_fast_comp/YEARLY_NN_OVERLAP/CAViaR_bond_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'_',num2str(time_elapsed),'.mat');%,date_end_str,'.mat');
    end
    if(  bond_scartati>1 )
        save(tosave,'BetaHat_rb_prefilter','output_rb_prefilter','TABLE_rb_prefilter','date_grid',...
            'bond_rates_subsampled_D','rb_subsampled_D','return_bond_GARCH','bond_rating_subsampled_D',...
            'Hit_bond','nome_bond','n_bond','date_finale_bond','bond_rates','Hit_bond_up','id_bond_scartati')
    else
        save(tosave,'BetaHat_rb_prefilter','output_rb_prefilter','TABLE_rb_prefilter','date_grid',...
            'bond_rates_subsampled_D','rb_subsampled_D','return_bond_GARCH','bond_rating_subsampled_D',...
            'Hit_bond','nome_bond','n_bond','date_finale_bond','bond_rates','Hit_bond_up')
    end
    clear  id_bond_scartati rb_subsampled_D bond_rates_subsampled_D bond_rating_subsampled_D BetaHat_rb_prefilter output_rb_prefilter TABLE_rb_prefilter date_grid bond_rates_subsampled_D rb_subsampled_D return_bond_GARCH Hit_bond  Hit_bond_up
    time_elapsed=time_elapsed+1;
    if(o_overlap)
        date_end=date_end+DAYS;
        waitbar(time_elapsed/99,wb);
    else
        YEAR=YEAR+1;
        waitbar(time_elapsed/12,wb);
        date_end = datenum(['31-Dec-',num2str(YEAR)]);
    end
end
