clear all
close all
clc

o_overlap=1;

%% Equity
D=2;
files = dir('../../data/Equities/');

fo = fopen('../../data/bank_eqcode.txt','r');
y  = fscanf(fo,'%c');
fclose(fo);

sx=1;
dx=12;
for n=1:33
    bank_eq_code(n,:) = y(sx:dx);
    sx=sx+13;
    dx=dx+13;
end
names=importdata('../../data/bank_name.txt');
N_files_eq = length(files)-2;
count=0;
for n=1:N_files_eq
    nomefile = files(n+2).name;
    if(strcmp(nomefile(end),'~'))
        delete(['../../data/Equities/',nomefile])
    else
        for m=1:33
            if(strcmp(bank_eq_code(m,:),nomefile))
                bank_name{n} = names(n);
            end
        end
        count=count+1;
        tmp = load(['../../data/Equities/',nomefile]);
        price_eq{count} = (tmp(end:-D:1,end))';
        I=find(isnan(price_eq{count})==1);
        brutti=length(I);
        if(brutti>0)
            J = find(isfinite(price_eq{count})==1);
            for b=1:brutti
                price_eq{count}(I(b)) = price_eq{count}(max(find(J<I(b))));
            end
        end
        date_eq{count} =  datenum(tmp(end:-D:1,1),tmp(end:-D:1,2),tmp(end:-D:1,3));
    end
end


time_elapsed = 1;
wb = waitbar(0,'Please wait.');
date_start = datenum('01-Jan-2001');
if(o_overlap)
    date_end = datenum('01-Jan-2006');
else
    YEAR = 2002;
    date_end = datenum('31-Dec-2002');
end
spec = garchset('Display','off','P',1,'Q',1);
final_date = datenum('14-Feb-2014');
DAYS = 30;
while date_end<=final_date
    date_end_str = datestr(date_end);
    every_1_day = date_start:1:date_end;
    every_1_day(find((weekday(every_1_day)==1) | (weekday(every_1_day)==7))) = [];
    date_grid = every_1_day(1:D:end);
    
    
    conf_lev = 0.10;
    for n=1:N_files_eq
        %Year,Month,n
        i=1;
        for t=date_grid
            Q=find(date_eq{n}<=t);
            if(isempty(Q))
                equity_price_subsampled_D{n}(i) = NaN;
            else
                tau=max(Q);
                equity_price_subsampled_D{n}(i) = price_eq{n}(tau);
            end
            i=i+1;
        end
        re_subsampled_D{n}=diff(log(equity_price_subsampled_D{n}));
        I = find(isnan(re_subsampled_D{n})==1);
        if(length(I)>0)
            min_nan(n) = max(I);
        else
            min_nan(n) = 0;
        end
        if(min_nan(n)==length(re_subsampled_D{n}))
            return_equity_GARCH{n} = NaN*ones(size(re_subsampled_D{n}));
            Hit_equity{n} = NaN*ones(size(re_subsampled_D{n}));
            Hit_equity_up{n} = NaN*ones(size(re_subsampled_D{n}));
        else
            try
                [Coeff,Errors,LLF,Innovations,Sigmas,Summary] = garchfit(spec,re_subsampled_D{n});
                Sig = zeros(size(re_subsampled_D{n}));
                Sig(1:min_nan(n))=NaN;
                Sig(min_nan(n)+1:end ) = Sigmas;
                return_equity_GARCH{n} = re_subsampled_D{n}./Sig;
                Y=re_subsampled_D{n}';
                Y = Y(min_nan(n)+1:end);
                LY = length(Y);
                yzeros= find(Y==0);
                non_zero = find(Y~=0);
                Ynnzero = Y(non_zero);
            catch
                return_equity_GARCH{n} = NaN*ones(size(re_subsampled_D{n}));
            end
            if(length(Ynnzero)<50)
                Hit_equity{n} = NaN*ones(size(re_subsampled_D{n}));
                Hit_equity_up{n} = NaN*ones(size(re_subsampled_D{n}));
            else
                try
                    [BetaHat_re_prefilter{n}, output_re_prefilter{n}, TABLE_re_prefilter{n}] = Engle_Manganelli_CAViaROptimisation_DEBUGGED(2,conf_lev,Ynnzero,100,2);
                    hit_tmp = zeros(LY,1);
                    hit_tmp(non_zero) = output_re_prefilter{n}.Hit+conf_lev;
                    hit_tmp(yzeros) = zeros(size(yzeros));
                    
                    hit_up_tmp =  zeros(LY,1);
                    hit_up_tmp(non_zero) = (Ynnzero>=output_re_prefilter{n}.VaR);
                    hit_up_tmp(yzeros) = zeros(size(yzeros));
                    
                    Hit_equity{n} = zeros(length(re_subsampled_D{n}),1);
                    Hit_equity{n}(1:min_nan(n))     = NaN*ones(min_nan(n),1);
                    Hit_equity{n}(min_nan(n)+1:end) = hit_tmp;
                    %Hit_equity{n}(min_nan(n)+1:end) = output_re_prefilter{n}.Hit+conf_lev;
                    %end
                    Hit_equity_up{n} = zeros(length(re_subsampled_D{n}),1);
                    Hit_equity_up{n}(1:min_nan(n))     = NaN*ones(min_nan(n),1);
                    Hit_equity_up{n}(min_nan(n)+1:end) = hit_up_tmp;
                catch
                    Hit_equity{n} = NaN*ones(size(re_subsampled_D{n}));
                    Hit_equity_up{n} = NaN*ones(size(re_subsampled_D{n}));
                end
            end
        end
        % Assume a symmetric (e.g. Gaussian) distribution...
    end
    if(o_overlap)
        tosave=strcat('../../../../data_reservoir/caviar/equities_fast_comp/',num2str(DAYS),'days/CAViaR_equity_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'_',num2str(time_elapsed),'.mat');%,date_end_str,'.mat');
    else
        tosave=strcat('../../../../data_reservoir/caviar/equities_fast_comp/YEARLY_NN_OVERLAP/CAViaR_equity_sample_varibile_D',num2str(D),'_alpha',num2str(conf_lev*100),'_',num2str(time_elapsed),'.mat');%,date_end_str,'.mat');
    end
    
    save(tosave,'BetaHat_re_prefilter','output_re_prefilter','TABLE_re_prefilter','price_eq','equity_price_subsampled_D','re_subsampled_D','Hit_equity',...
        'bank_name','return_equity_GARCH','date_grid','N_files_eq','date_eq','Hit_equity_up');
    clear   min_nan equity_price_subsampled_D  re_subsampled_D return_equity_GARCH BetaHat_re_prefilter output_re_prefilter TABLE_re_prefilter Hit_equity Hit_equity_up
    
    time_elapsed=time_elapsed+1;
    if(o_overlap)
        date_end=date_end+DAYS;
        waitbar(time_elapsed/(99),wb);
    else
        YEAR=YEAR+1;
        waitbar(time_elapsed/9,wb);
        date_end = datenum(['31-Dec-',num2str(YEAR)]);
    end
end







