function Q = hong_etal_test(rho,M,kernel_type)

Tminus1 = length(rho);
T = Tminus1+1;
vect1 = 1-((1:Tminus1)/T);
vect2 = 1-((2:T)/T);
z = (1:Tminus1)/M;
if(strcmp(kernel_type,'DAN'))
 k = sin(pi*z)./(pi*z); 
elseif(strcmp(kernel_type,'TRUN'))
 k = (abs(z)<=1);
else
 disp('WARNING: Kernel not available, using Danniell kernel instead.')
 k = sin(pi*z)./(pi*z); 
end

k = k.^2; 
C1TM = sum(vect1.*k); 
k4 = k.^2; 
D1TM = 2*sum(vect1.*vect2.*k4);
rho = rho.^2;
k = k';
Q = (T*sum(k.*rho)-C1TM)./sqrt(D1TM);
end

